| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KXMLGUIFactory Class Reference

KXMLGUIFactory, together with KXMLGUIClient objects, can be used to create a GUI of container widgets (like menus, toolbars, etc.) and container items (menu items, toolbar buttons, etc.) from an XML document and action objects. More...

`#include <kxmlguifactory.h>`

Inheritance diagram for KXMLGUIFactory:

[legend]
Collaboration diagram for KXMLGUIFactory:

[legend]
List of all members.

## Public Slots
int | configureShortcuts (bool bAllowLetterShortcuts=true, bool bSaveSettings=true)
## Signals
void | clientAdded (KXMLGUIClient *client)
void | clientRemoved (KXMLGUIClient *client)
## Public Member Functions
| KXMLGUIFactory (KXMLGUIBuilder *builder, QObject *parent=0, const char *name=0)
| ~KXMLGUIFactory ()
void | addClient (KXMLGUIClient *client)
void | removeClient (KXMLGUIClient *client)
void | plugActionList (KXMLGUIClient *client, const QString &name, const QPtrList< KAction > &actionList)
void | unplugActionList (KXMLGUIClient *client, const QString &name)
QPtrList< KXMLGUIClient > | clients () const
QWidget * | container (const QString &containerName, KXMLGUIClient *client, bool useTagName=false)
QPtrList< QWidget > | containers (const QString &tagName)
void | reset ()
void | resetContainer (const QString &containerName, bool useTagName=false)
## Static Public Member Functions
static QString | readConfigFile (const QString &filename, bool never_null, const KInstance *instance=0)
static QString | readConfigFile (const QString &filename, const KInstance *instance=0)
static bool | saveConfigFile (const QDomDocument &doc, const QString &filename, const KInstance *instance=0)
static QString | documentToXML (const QDomDocument &doc)
static QString | elementToXML (const QDomElement &elem)
static void | removeDOMComments (QDomNode &node)
static QDomElement | actionPropertiesElement (QDomDocument &doc)
static QDomElement | findActionByName (QDomElement &elem, const QString &sName, bool create)
## Protected Member Functions
virtual void | virtual_hook (int id, void *data)
## Friends
class | KXMLGUI::BuildHelper

## Detailed Description

KXMLGUIFactory, together with KXMLGUIClient objects, can be used to create a GUI of container widgets (like menus, toolbars, etc.) and container items (menu items, toolbar buttons, etc.) from an XML document and action objects.

Each KXMLGUIClient represents a part of the GUI, composed from containers and actions. KXMLGUIFactory takes care of building (with the help of a KXMLGUIBuilder) and merging the GUI from an unlimited number of clients.

Each client provides XML through a QDomDocument and actions through a KActionCollection . The XML document contains the rules for how to merge the GUI.

KXMLGUIFactory processes the DOM tree provided by a client and plugs in the client's actions, according to the XML and the merging rules of previously inserted clients. Container widgets are built via a KXMLGUIBuilder , which has to be provided with the KXMLGUIFactory constructor.

Definition at line 62 of file kxmlguifactory.h.

## Constructor & Destructor Documentation

KXMLGUIFactory::KXMLGUIFactory | ( | KXMLGUIBuilder * | builder,
|  | QObject * | parent = `0`,
|  | const char * | name = `0`
| ) |

| Constructs a KXMLGUIFactory. The provided `builder` KXMLGUIBuilder will be called for creating and removing container widgets, when clients are added/removed from the GUI. Note that the ownership of the given KXMLGUIBuilder object won't be transferred to this KXMLGUIFactory, so you have to take care of deleting it properly. Definition at line 206 of file kxmlguifactory.cpp.

KXMLGUIFactory::~KXMLGUIFactory | ( |  | ) |

| Destructor. Definition at line 219 of file kxmlguifactory.cpp.

## Member Function Documentation

void KXMLGUIFactory::removeDOMComments | ( | QDomNode & | node | ) | `[static]`

| Removes all QDomComment objects from the specified node and all its children. Definition at line 186 of file kxmlguifactory.cpp. References QDomNode::isNull(), QDomNode::nextSibling(), QDomNode::nodeType(), and QDomNode::removeChild().

void KXMLGUIFactory::addClient | ( | KXMLGUIClient * | client | ) |

| Creates the GUI described by the QDomDocument of the client, using the client's actions, and merges it with the previously created GUI. This also means that the order in which clients are added to the factory is relevant; assuming that your application supports plugins, you should first add your application to the factory and then the plugin, so that the plugin's UI is merged into the UI of your application, and not the other way round. Definition at line 224 of file kxmlguifactory.cpp. References QString::append(), QDomElement::attribute(), QPtrListIterator::current(), QDomDocument::documentElement(), endl(), kdDebug(), QString::lower(), and KGlobal::staticQString(). Referenced by KMainWindow::createGUI(), KEditToolbarWidget::save(), and KMainWindow::setStandardToolBarMenuEnabled().

void KXMLGUIFactory::removeClient | ( | KXMLGUIClient * | client | ) |

| Removes the GUI described by the client, by unplugging all provided actions and removing all owned containers (and storing container state information in the given client). Definition at line 321 of file kxmlguifactory.cpp. References QPtrListIterator::current(), QDomDocument::documentElement(), endl(), kdDebug(), and QPtrListIterator::toLast(). Referenced by KMainWindow::createGUI(), KEditToolbarWidget::save(), and KMainWindow::setStandardToolBarMenuEnabled().

QPtrList< KXMLGUIClient > KXMLGUIFactory::clients | ( |  | ) | const

| Returns a list of all clients currently added to this factory. Definition at line 379 of file kxmlguifactory.cpp.

QWidget * KXMLGUIFactory::container | ( | const QString & | containerName,
|  | KXMLGUIClient * | client,
|  | bool | useTagName = `false`
| ) |

| Use this method to get access to a container widget with the name specified with `containerName` and which is owned by the `client`. The container name is specified with a "name" attribute in the XML document. This function is particularly useful for getting hold of a popupmenu defined in an XMLUI file. For instance:
     QPopupMenu *popup = static_cast<QPopupMenu*>(factory()->container("my_popup",this));
  where `"my_popup"` is the name of the menu in the XMLUI file, and `"this"` is XMLGUIClient which owns the popupmenu (e.g. the mainwindow, or the part, or the plugin...) Parameters:
  | containerName | Name of the container widget
  | client | Owner of the container widget
  | useTagName | Specifies whether to compare the specified name with the name attribute or the tag name.
This method may return 0L if no container with the given name exists or is not owned by the client. Definition at line 384 of file kxmlguifactory.cpp. Referenced by resetContainer().

void KXMLGUIFactory::reset | ( |  | ) |

| Use this method to free all memory allocated by the KXMLGUIFactory. This deletes the internal node tree and therefore resets the internal state of the class. Please note that the actual GUI is NOT touched at all, meaning no containers are deleted nor any actions unplugged. That is something you have to do on your own. So use this method only if you know what you are doing :-) (also note that this will call KXMLGUIClient::setFactory( 0L ) for all inserted clients) Definition at line 406 of file kxmlguifactory.cpp.

void KXMLGUIFactory::resetContainer | ( | const QString & | containerName,
|  | bool | useTagName = `false`
| ) |

| Use this method to free all memory allocated by the KXMLGUIFactory for a specific container, including all child containers and actions. This deletes the internal node subtree for the specified container. The actual GUI is not touched, no containers are deleted or any actions unplugged. Use this method only if you know what you are doing :-) (also note that this will call KXMLGUIClient::setFactory( 0L ) for all clients of the container) Definition at line 413 of file kxmlguifactory.cpp. References container(). Referenced by KMainWindow::createGUI().

int KXMLGUIFactory::configureShortcuts | ( | bool | bAllowLetterShortcuts = `true`,
|  | bool | bSaveSettings = `true`
| ) | `[slot]`

| Show a standard configure shortcut for every action in this factory. This slot can be connected dirrectly to the action to configure shortcuts. This is very simple to do that by adding a single line
     KStdAction::keyBindings( guiFactory(), SLOT( configureShortcuts() ), actionCollection() );
  Parameters:
  | bAllowLetterShortcuts | Set to false if unmodified alphanumeric keys ('A', '1', etc.) are not permissible shortcuts.
  | bSaveSettings | if true, the settings will also be saved back to the *uirc file which they were intially read from.
Since: 3.3 Definition at line 553 of file kxmlguifactory.cpp. References KXMLGUIClient::actionCollection(), KKeyDialog::configure(), KKeyDialog::insert(), QString::isEmpty(), QObject::parent(), and KXMLGUIClient::xmlFile().

The documentation for this class was generated from the following files:

- kxmlguifactory.h
- kxmlguifactory.cpp

This file is part of the documentation for kdeui Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:22:43 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003